Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -803,5 +442,5 @@
             dimension%values_int8 = values_int8
          ELSEIF ( SIZE( values_int8 ) == 1 )  THEN
-            dimension%values_int8(:) = values_int8
+            dimension%values_int8(:) = values_int8(1)
          ELSE
             return_value = 2
@@ -812,5 +451,5 @@
             dimension%values_int16 = values_int16
          ELSEIF ( SIZE( values_int16 ) == 1 )  THEN
-            dimension%values_int16(:) = values_int16
+            dimension%values_int16(:) = values_int16(1)
          ELSE
             return_value = 2
@@ -821,5 +460,5 @@
             dimension%values_int32 = values_int32
          ELSEIF ( SIZE( values_int32 ) == 1 )  THEN
-            dimension%values_int32(:) = values_int32
+            dimension%values_int32(:) = values_int32(1)
          ELSE
             return_value = 2
@@ -830,5 +469,5 @@
             dimension%values_intwp = values_intwp
          ELSEIF ( SIZE( values_intwp ) == 1 )  THEN
-            dimension%values_intwp(:) = values_intwp
+            dimension%values_intwp(:) = values_intwp(1)
          ELSE
             return_value = 2
@@ -839,5 +478,5 @@
             dimension%values_real32 = values_real32
          ELSEIF ( SIZE( values_real32 ) == 1 )  THEN
-            dimension%values_real32(:) = values_real32
+            dimension%values_real32(:) = values_real32(1)
          ELSE
             return_value = 2
@@ -848,5 +487,5 @@
             dimension%values_real64 = values_real64
          ELSEIF ( SIZE( values_real64 ) == 1 )  THEN
-            dimension%values_real64(:) = values_real64
+            dimension%values_real64(:) = values_real64(1)
          ELSE
             return_value = 2
@@ -857,5 +496,5 @@
             dimension%values_realwp = values_realwp
          ELSEIF ( SIZE( values_realwp ) == 1 )  THEN
-            dimension%values_realwp(:) = values_realwp
+            dimension%values_realwp(:) = values_realwp(1)
          ELSE
             return_value = 2
@@ -863,13 +502,16 @@
       ELSE
          return_value = 1
-         CALL internal_message( 'error', routine_name // ': ' // &
-                                         TRIM( name ) // ': no values given' )
+         CALL internal_message( 'error', routine_name //                    &
+                                ': no values given ' //                     &
+                                '(dimension "' // TRIM( dimension_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
 
       IF ( return_value == 2 )  THEN
          return_value = 1
-         CALL internal_message( 'error', routine_name //                   &
-                                         ': dimension ' // TRIM( name ) // &
-                                         ': number of values and given bounds do not match' )
+         CALL internal_message( 'error', routine_name //                               &
+                                ': number of values and given bounds do not match ' // &
+                                '(dimension "' // TRIM( dimension_name ) //            &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
 
@@ -877,107 +519,118 @@
       IF ( PRESENT( mask )  .AND.  return_value == 0 )  THEN
 
-         dimension%is_masked = .TRUE.
-
          IF ( dimension%length == SIZE( mask ) )  THEN
 
-            dimension%length_mask = COUNT( mask )
-
-            ALLOCATE( dimension%mask(dimension%bounds(1):dimension%bounds(2)) )
-            ALLOCATE( dimension%masked_indices(0:dimension%length_mask-1) )
-
-            dimension%mask = mask
-
-            !-- Save masked positions and masked values
-            IF ( ALLOCATED( dimension%values_int8 ) )  THEN
-
-               ALLOCATE( dimension%masked_values_int8(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_int8(j) = dimension%values_int8(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED( dimension%values_int16 ) )  THEN
-
-               ALLOCATE( dimension%masked_values_int16(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_int16(j) = dimension%values_int16(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED( dimension%values_int32 ) )  THEN
-
-               ALLOCATE( dimension%masked_values_int32(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_int32(j) = dimension%values_int32(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED( dimension%values_intwp ) )  THEN
-
-               ALLOCATE( dimension%masked_values_intwp(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_intwp(j) = dimension%values_intwp(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED( dimension%values_real32 ) )  THEN
-
-               ALLOCATE( dimension%masked_values_real32(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_real32(j) = dimension%values_real32(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED(dimension%values_real64) )  THEN
-
-               ALLOCATE( dimension%masked_values_real64(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = 0, dimension%length-1
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_real64(j) = dimension%values_real64(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ELSEIF ( ALLOCATED(dimension%values_realwp) )  THEN
-
-               ALLOCATE( dimension%masked_values_realwp(0:dimension%length_mask-1) )
-               j = 0
-               DO  i = dimension%bounds(1), dimension%bounds(2)   !> @todo change loop also for other data types
-                  IF ( dimension%mask(i) )  THEN
-                     dimension%masked_values_realwp(j) = dimension%values_realwp(i)
-                     dimension%masked_indices(j) = i
-                     j = j + 1
-                  ENDIF
-               ENDDO
-
-            ENDIF
+            IF ( ALL( mask ) )  THEN
+
+               CALL internal_message( 'debug', routine_name //                              &
+                                      ': mask contains only TRUE values. Ignoring mask ' // &
+                                      '(dimension "' // TRIM( dimension_name ) //           &
+                                      '", file "' // TRIM( file_name ) // '")!' )
+
+            ELSE
+
+               dimension%is_masked = .TRUE.
+               dimension%length_mask = COUNT( mask )
+
+               ALLOCATE( dimension%mask(dimension%bounds(1):dimension%bounds(2)) )
+               ALLOCATE( dimension%masked_indices(0:dimension%length_mask-1) )
+
+               dimension%mask = mask
+
+               !-- Save masked positions and masked values
+               IF ( ALLOCATED( dimension%values_int8 ) )  THEN
+
+                  ALLOCATE( dimension%masked_values_int8(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_int8(j) = dimension%values_int8(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED( dimension%values_int16 ) )  THEN
+
+                  ALLOCATE( dimension%masked_values_int16(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_int16(j) = dimension%values_int16(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED( dimension%values_int32 ) )  THEN
+
+                  ALLOCATE( dimension%masked_values_int32(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i =dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_int32(j) = dimension%values_int32(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED( dimension%values_intwp ) )  THEN
+
+                  ALLOCATE( dimension%masked_values_intwp(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_intwp(j) = dimension%values_intwp(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED( dimension%values_real32 ) )  THEN
+
+                  ALLOCATE( dimension%masked_values_real32(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_real32(j) = dimension%values_real32(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED(dimension%values_real64) )  THEN
+
+                  ALLOCATE( dimension%masked_values_real64(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_real64(j) = dimension%values_real64(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ELSEIF ( ALLOCATED(dimension%values_realwp) )  THEN
+
+                  ALLOCATE( dimension%masked_values_realwp(0:dimension%length_mask-1) )
+                  j = 0
+                  DO  i = dimension%bounds(1), dimension%bounds(2)
+                     IF ( dimension%mask(i) )  THEN
+                        dimension%masked_values_realwp(j) = dimension%values_realwp(i)
+                        dimension%masked_indices(j) = i
+                        j = j + 1
+                     ENDIF
+                  ENDDO
+
+               ENDIF
+
+            ENDIF  ! if not all mask = true
 
          ELSE
             return_value = 1
-            CALL internal_message( 'error', routine_name //                   &
-                                            ': dimension ' // TRIM( name ) // &
-                                            ': size of mask and given bounds do not match' )
+            CALL internal_message( 'error', routine_name //                           &
+                                   ': size of mask and given bounds do not match ' // &
+                                   '(dimension "' // TRIM( dimension_name ) //        &
+                                   '", file "' // TRIM( file_name ) // '")!' )
          ENDIF
 
@@ -989,7 +642,6 @@
       CALL internal_message( 'error', routine_name //                                       &
                              ': at least one but no more than two bounds must be given ' // &
-                             '(dimension "' // TRIM( name ) //                              &
-                             '", file "' // TRIM( filename ) //                             &
-                             '")!' )
+                             '(dimension "' // TRIM( dimension_name ) //                    &
+                             '", file "' // TRIM( file_name ) // '")!' )
 
    ENDIF
@@ -998,20 +650,22 @@
    IF ( return_value == 0 )  THEN
 
-      DO  f = 1, nf
-
-         IF ( TRIM( filename ) == files(f)%name )  THEN
+      DO  f = 1, nfiles
+
+         IF ( TRIM( file_name ) == files(f)%name )  THEN
 
             IF ( files(f)%is_init )  THEN
 
                return_value = 1
-               CALL internal_message( 'error',                           &
-                       routine_name // ': file "' // TRIM( filename ) // &
-                       '" is already initialized. No further dimension definition allowed!' )
+               CALL internal_message( 'error', routine_name //                      &
+                                      ': file already initialized. ' //             &
+                                      'No further dimension definition allowed ' // &
+                                      '(dimension "' // TRIM( dimension_name ) //   &
+                                      '", file "' // TRIM( file_name ) // '")!' )
                EXIT
 
             ELSEIF ( .NOT. ALLOCATED( files(f)%dimensions ) )  THEN
 
-               ndim = 1
-               ALLOCATE( files(f)%dimensions(ndim) )
+               ndims = 1
+               ALLOCATE( files(f)%dimensions(ndims) )
 
             ELSE
@@ -1022,10 +676,9 @@
                      IF ( files(f)%variables(i)%name == dimension%name )  THEN
                         return_value = 1
-                        CALL internal_message( 'error', routine_name //                   &
-                                               ': file "' // TRIM( filename ) //          &
-                                               '" already has a variable of name "' //    &
-                                               TRIM( dimension%name ) // '" defined. ' // &
-                                               'Defining a dimension of the same ' //     &
-                                               'name is not allowed.' )
+                        CALL internal_message( 'error', routine_name //                    &
+                                ': file already has a variable of this name defined. ' //  &
+                                'Defining a dimension of the same name is not allowed ' // &
+                                '(dimension "' // TRIM( dimension_name ) //                &
+                                '", file "' // TRIM( file_name ) // '")!' )
                         EXIT
                      ENDIF
@@ -1035,13 +688,13 @@
                IF ( return_value == 0 )  THEN
                   !-- Check if dimension already exists in file
-                  ndim = SIZE( files(f)%dimensions )
-
-                  DO  d = 1, ndim
+                  ndims = SIZE( files(f)%dimensions )
+
+                  DO  d = 1, ndims
                      IF ( files(f)%dimensions(d)%name == dimension%name )  THEN
                         return_value = 1
-                        CALL internal_message( 'error',            &
-                                routine_name //                    &
-                                ': dimension "' // TRIM( name ) // &
-                                '" already exists in file "' // TRIM( filename ) // '"' )
+                        CALL internal_message( 'error', routine_name //     &
+                                ': dimension already exists in file ' //    &
+                                '(dimension "' // TRIM( dimension_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
                         EXIT
                      ENDIF
@@ -1050,11 +703,11 @@
                   !-- Extend dimension list
                   IF ( return_value == 0 )  THEN
-                     ALLOCATE( dims_tmp(ndim) )
-                     dims_tmp = files(f)%dimensions
+                     ALLOCATE( dimensions_tmp(ndims) )
+                     dimensions_tmp = files(f)%dimensions
                      DEALLOCATE( files(f)%dimensions )
-                     ndim = ndim + 1
-                     ALLOCATE( files(f)%dimensions(ndim) )
-                     files(f)%dimensions(:ndim-1) = dims_tmp
-                     DEALLOCATE( dims_tmp )
+                     ndims = ndims + 1
+                     ALLOCATE( files(f)%dimensions(ndims) )
+                     files(f)%dimensions(:ndims-1) = dimensions_tmp
+                     DEALLOCATE( dimensions_tmp )
                   ENDIF
                ENDIF
@@ -1063,5 +716,5 @@
 
             !-- Add new dimension to database
-            IF ( return_value == 0 )  files(f)%dimensions(ndim) = dimension
+            IF ( return_value == 0 )  files(f)%dimensions(ndims) = dimension
 
             EXIT
@@ -1070,9 +723,9 @@
       ENDDO
 
-      IF ( f > nf )  THEN
+      IF ( f > nfiles )  THEN
          return_value = 1
-         CALL internal_message( 'error', routine_name //                           &
-                                ': file not found (dimension "' // TRIM( name ) // &
-                                '", file "' // TRIM( filename ) // '")!' )
+         CALL internal_message( 'error', routine_name //                                     &
+                                ': file not found (dimension "' // TRIM( dimension_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
 
@@ -1085,7 +738,10 @@
 ! ------------
 !> Add variable to database.
+!> If a variable is identical for each MPI rank, the optional argument 'is_global' should be set to
+!> TRUE. This flags the variable to be a global variable and is later only written once by the
+!> master output rank.
 !> Example call:
-!>   dom_def_var( filename =  'DATA_OUTPUT_3D', &
-!>                name = 'u', &
+!>   dom_def_var( file_name =  'my_output_file_name', &
+!>                variable_name = 'u', &
 !>                dimension_names = (/'x   ', 'y   ', 'z   ', 'time'/), &
 !>                output_type = 'real32' )
@@ -1103,10 +759,10 @@
 !>          ALLOCATE( u(<z>,<y>,<x>) )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_var( filename, name, dimension_names, output_type, is_global ) &
+FUNCTION dom_def_var( file_name, variable_name, dimension_names, output_type, is_global ) &
             RESULT( return_value )
 
-   CHARACTER(LEN=*), INTENT(IN) ::  filename     !< name of file
-   CHARACTER(LEN=*), INTENT(IN) ::  name         !< name of variable
-   CHARACTER(LEN=*), INTENT(IN) ::  output_type  !< data type of variable
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
+   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+   CHARACTER(LEN=*), INTENT(IN) ::  output_type    !< data type of variable
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_var'  !< name of this routine
@@ -1114,25 +770,25 @@
    CHARACTER(LEN=*), DIMENSION(:), INTENT(IN) ::  dimension_names  !< list of dimension names
 
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  i             !< loop index
-   INTEGER(iwp) ::  nvar          !< number of variables in file
-   INTEGER(iwp) ::  return_value  !< return value
-
-   LOGICAL                       ::  found = .FALSE.  !< true if requested dimension is defined in file
-   LOGICAL, INTENT(IN), OPTIONAL ::  is_global        !< true if variable is global (same on all PE)
-
-   TYPE(variable_type) ::  variable  !< new variable
-
-   TYPE(variable_type), DIMENSION(:), ALLOCATABLE ::  vars_tmp  !< temporary variable list
+   INTEGER ::  d             !< loop index
+   INTEGER ::  f             !< loop index
+   INTEGER ::  i             !< loop index
+   INTEGER ::  nvars         !< number of variables in file
+   INTEGER ::  return_value  !< return value
+
+   LOGICAL                       ::  found      !< true if requested dimension is defined in file
+   LOGICAL, INTENT(IN), OPTIONAL ::  is_global  !< true if variable is global (same on all PE)
+
+   TYPE(variable_type)                            ::  variable       !< new variable
+   TYPE(variable_type), DIMENSION(:), ALLOCATABLE ::  variables_tmp  !< temporary variable list
 
 
    return_value = 0
-
-   CALL internal_message( 'debug', routine_name //                  &
-                          ': define variable "' // TRIM( name ) // &
-                          '" in file "' // TRIM( filename ) // '"' )
-
-   variable%name = TRIM( name )
+   found = .FALSE.
+
+   CALL internal_message( 'debug', routine_name //                                     &
+                          ': define variable (variable "' // TRIM( variable_name ) //  &
+                          '", file "' // TRIM( file_name ) // '")' )
+
+   variable%name = TRIM( variable_name )
 
    ALLOCATE( variable%dimension_names(SIZE( dimension_names )) )
@@ -1150,13 +806,15 @@
 
    !-- Add variable to database
-   DO  f = 1, nf
-
-      IF ( TRIM( filename ) == files(f)%name )  THEN
+   DO  f = 1, nfiles
+
+      IF ( TRIM( file_name ) == files(f)%name )  THEN
 
          IF ( files(f)%is_init )  THEN
 
             return_value = 1
-            CALL internal_message( 'error', routine_name // ': file "' // TRIM( filename ) // &
-                    '" is already initialized. No further variable definition allowed!' )
+            CALL internal_message( 'error', routine_name //                                  &
+                    ': file already initialized. No further variable definition allowed ' // &
+                    '(variable "' // TRIM( variable_name ) //                                &
+                    '", file "' // TRIM( file_name ) // '")!' )
             EXIT
 
@@ -1167,9 +825,9 @@
                IF ( files(f)%dimensions(d)%name == variable%name )  THEN
                   return_value = 1
-                  CALL internal_message( 'error', routine_name //                  &
-                                         ': file "' // TRIM( filename ) //         &
-                                         '" already has a dimension of name "' //  &
-                                         TRIM( variable%name ) // '" defined. ' // &
-                                         'Defining a variable of the same name is not allowed.' )
+                  CALL internal_message( 'error', routine_name //                    &
+                          ': file already has a dimension of this name defined. ' // &
+                          'Defining a variable of the same name is not allowed ' //  &
+                          '(variable "' // TRIM( variable_name ) //                  &
+                          '", file "' // TRIM( file_name ) // '")!' )
                   EXIT
                ENDIF
@@ -1188,11 +846,9 @@
                   IF ( .NOT. found )  THEN
                      return_value = 1
-                     CALL internal_message( 'error',                                            &
-                                            routine_name //                                     &
-                                            ': required dimension "' //                         &
-                                            TRIM( variable%dimension_names(i) ) //              &
-                                            '" for variable "' // TRIM( name ) //               &
-                                            '" is not defined in file "' // TRIM( filename ) // &
-                                            '"!' )
+                     CALL internal_message( 'error', routine_name //                            &
+                             ': required dimension "'//  TRIM( variable%dimension_names(i) ) // &
+                             '" for variable is not defined ' //                                &
+                             '(variable "' // TRIM( variable_name ) //                          &
+                             '", file "' // TRIM( file_name ) // '")!' )
                      EXIT
                   ENDIF
@@ -1203,8 +859,8 @@
 
             return_value = 1
-            CALL internal_message( 'error', routine_name //                        &
-                                   ': cannot define variable "' // TRIM( name ) // &
-                                   '" in file "' // TRIM( filename ) //            &
-                                   '" because no dimensions defined in file.' )
+            CALL internal_message( 'error', routine_name //                      &
+                    ': no dimensions defined in file. Cannot define variable '// &
+                    '(variable "' // TRIM( variable_name ) //                    &
+                    '", file "' // TRIM( file_name ) // '")!' )
 
          ENDIF
@@ -1215,17 +871,17 @@
             IF ( .NOT. ALLOCATED( files(f)%variables ) )  THEN
 
-               nvar = 1
-               ALLOCATE( files(f)%variables(nvar) )
+               nvars = 1
+               ALLOCATE( files(f)%variables(nvars) )
 
             ELSE
 
-               nvar = SIZE( files(f)%variables )
-               DO  i = 1, nvar
+               nvars = SIZE( files(f)%variables )
+               DO  i = 1, nvars
                   IF ( files(f)%variables(i)%name == variable%name )  THEN
                      return_value = 1
-                     CALL internal_message( 'error', routine_name //          &
-                                            ': variable "' // TRIM( name ) // &
-                                            '" already exists in file "' //   &
-                                            TRIM( filename ) // '"!' )
+                     CALL internal_message( 'error', routine_name //   &
+                             ': variable already exists '//            &
+                             '(variable "' // TRIM( variable_name ) // &
+                             '", file "' // TRIM( file_name ) // '")!' )
                      EXIT
                   ENDIF
@@ -1234,11 +890,11 @@
                IF ( return_value == 0 )  THEN
                   !-- Extend variable list
-                  ALLOCATE( vars_tmp(nvar) )
-                  vars_tmp = files(f)%variables
+                  ALLOCATE( variables_tmp(nvars) )
+                  variables_tmp = files(f)%variables
                   DEALLOCATE( files(f)%variables )
-                  nvar = nvar + 1
-                  ALLOCATE( files(f)%variables(nvar) )
-                  files(f)%variables(:nvar-1) = vars_tmp
-                  DEALLOCATE( vars_tmp )
+                  nvars = nvars + 1
+                  ALLOCATE( files(f)%variables(nvars) )
+                  files(f)%variables(:nvars-1) = variables_tmp
+                  DEALLOCATE( variables_tmp )
                ENDIF
 
@@ -1246,5 +902,5 @@
 
             !-- Add new variable to database
-            IF ( return_value == 0 )  files(f)%variables(nvar) = variable
+            IF ( return_value == 0 )  files(f)%variables(nvars) = variable
 
          ENDIF
@@ -1256,9 +912,9 @@
    ENDDO
 
-   IF ( f > nf )  THEN
+   IF ( f > nfiles )  THEN
       return_value = 1
-      CALL internal_message( 'error', routine_name //                           &
-                             ': file not found (variable "' // TRIM( name ) //  &
-                             '", file "' // TRIM( filename ) // '")!' )
+      CALL internal_message( 'error', routine_name //                                   &
+                             ': file not found (variable "' // TRIM( variable_name ) // &
+                             '", file "' // TRIM( file_name ) // '")!' )
    ENDIF
 
@@ -1269,15 +925,37 @@
 ! ------------
 !> Create attribute with value of type character.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_char( filename, variable, name, value, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file
-   CHARACTER(LEN=*), INTENT(IN)           ::  name      !< name of attribute
-   CHARACTER(LEN=*), INTENT(IN)           ::  value     !< attribute value
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable  !< name of variable
+!> If the optional argument 'variable_name' is given, the attribute is added to the respective
+!> variable or dimension of that name. Otherwise, the attribute is added as a global attribute to
+!> the file itself.
+!> If an attribute of similar name already exists, it is updated (overwritten) with the new value.
+!> If the optional argument 'append' is set TRUE, the value of an already existing attribute of
+!> similar name is appended by the new value instead of overwritten.
+!> Example call:
+!>   - define a global file attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value='This is the attribute value' )
+!>   - define a variable attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   variable_name='my_variable', &
+!>                   attribute_name='my_attribute', &
+!>                   value='This is the attribute value' )
+!>   - append an attribute:
+!>      dom_def_att( file_name='my_output_file_name', &
+!>                   attribute_name='my_attribute', &
+!>                   value=' and this part was appended', append=.TRUE. )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_att_char( file_name, variable_name, attribute_name, value, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+   CHARACTER(LEN=*),      INTENT(IN)           ::  value                   !< attribute value
+   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
 
    ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_char'  !< name of routine
 
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  return_value  !< return value
 
    LOGICAL                       ::  append_internal  !< same as 'append'
